Index: /palm/trunk/SOURCE/data_output_netcdf4_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4140)
+++ /palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4141)
@@ -491,68 +492,63 @@
 !> Write variable of different kind into netcdf file.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE netcdf4_write_variable(                                        &
-              file_id, var_id, bounds_start, value_counts, bounds_origin, &
-              is_global,                                                  &
-              var_int8_0d,   var_int8_1d,   var_int8_2d,   var_int8_3d,   &
-              var_int16_0d,  var_int16_1d,  var_int16_2d,  var_int16_3d,  &
-              var_int32_0d,  var_int32_1d,  var_int32_2d,  var_int32_3d,  &
-              var_intwp_0d,  var_intwp_1d,  var_intwp_2d,  var_intwp_3d,  &
-              var_real32_0d, var_real32_1d, var_real32_2d, var_real32_3d, &
-              var_real64_0d, var_real64_1d, var_real64_2d, var_real64_3d, &
-              var_realwp_0d, var_realwp_1d, var_realwp_2d, var_realwp_3d, &
+SUBROUTINE netcdf4_write_variable(                                                    &
+              file_id, variable_id, bounds_start, value_counts, bounds_origin,        &
+              is_global,                                                              &
+              values_int8_0d,   values_int8_1d,   values_int8_2d,   values_int8_3d,   &
+              values_int16_0d,  values_int16_1d,  values_int16_2d,  values_int16_3d,  &
+              values_int32_0d,  values_int32_1d,  values_int32_2d,  values_int32_3d,  &
+              values_intwp_0d,  values_intwp_1d,  values_intwp_2d,  values_intwp_3d,  &
+              values_real32_0d, values_real32_1d, values_real32_2d, values_real32_3d, &
+              values_real64_0d, values_real64_1d, values_real64_2d, values_real64_3d, &
+              values_realwp_0d, values_realwp_1d, values_realwp_2d, values_realwp_3d, &
               return_value )
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_write_variable'  !< name of this routine
 
-   INTEGER(iwp)              ::  d             !< loop index
-   INTEGER(iwp), INTENT(IN)  ::  file_id       !< file ID
-   INTEGER                   ::  my_rank       !< MPI rank of processor
-   INTEGER(iwp)              ::  nc_stat       !< netcdf return value
-   INTEGER(iwp)              ::  ndim          !< number of dimensions of variable in file
-   INTEGER(iwp), INTENT(OUT) ::  return_value  !< return value
-   INTEGER(iwp), INTENT(IN)  ::  var_id        !< variable ID
-
-   INTEGER(iwp), DIMENSION(:), INTENT(IN)  ::  bounds_origin  !< starting index of each dimension
-   INTEGER(iwp), DIMENSION(:), INTENT(IN)  ::  bounds_start   !< starting index of variable
-   INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  dim_ids        !< IDs of dimensions of variable in file
-   INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  dim_lengths    !< length of dimensions of variable in file
-   INTEGER(iwp), DIMENSION(:), INTENT(IN)  ::  value_counts   !< count of values along each dimension to be written
-
-   INTEGER(KIND=1), POINTER, INTENT(IN), OPTIONAL                               ::  var_int8_0d  !< output variable
-   INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  var_int8_1d  !< output variable
-   INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  var_int8_2d  !< output variable
-   INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  var_int8_3d  !< output variable
-
-   INTEGER(KIND=2), POINTER, INTENT(IN), OPTIONAL                               ::  var_int16_0d  !< output variable
-   INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  var_int16_1d  !< output variable
-   INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  var_int16_2d  !< output variable
-   INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  var_int16_3d  !< output variable
-
-   INTEGER(KIND=4), POINTER, INTENT(IN), OPTIONAL                               ::  var_int32_0d  !< output variable
-   INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  var_int32_1d  !< output variable
-   INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  var_int32_2d  !< output variable
-   INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  var_int32_3d  !< output variable
-
-   INTEGER(iwp), POINTER, INTENT(IN), OPTIONAL                               ::  var_intwp_0d  !< output variable
-   INTEGER(iwp), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  var_intwp_1d  !< output variable
-   INTEGER(iwp), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  var_intwp_2d  !< output variable
-   INTEGER(iwp), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  var_intwp_3d  !< output variable
+   INTEGER              ::  d             !< loop index
+   INTEGER, INTENT(IN)  ::  file_id       !< file ID
+   INTEGER              ::  my_rank       !< MPI rank of processor
+   INTEGER              ::  nc_stat       !< netcdf return value
+   INTEGER              ::  ndims         !< number of dimensions of variable in file
+   INTEGER, INTENT(OUT) ::  return_value  !< return value
+   INTEGER, INTENT(IN)  ::  variable_id   !< variable ID
+
+   INTEGER, DIMENSION(:),              INTENT(IN)  ::  bounds_origin      !< starting index of each dimension
+   INTEGER, DIMENSION(:),              INTENT(IN)  ::  bounds_start       !< starting index of variable
+   INTEGER, DIMENSION(:), ALLOCATABLE              ::  dimension_ids      !< IDs of dimensions of variable in file
+   INTEGER, DIMENSION(:), ALLOCATABLE              ::  dimension_lengths  !< length of dimensions of variable in file
+   INTEGER, DIMENSION(:),              INTENT(IN)  ::  value_counts       !< count of values along each dimension to be written
+
+   INTEGER(KIND=1), POINTER,             INTENT(IN), OPTIONAL                   ::  values_int8_0d   !< output variable
+   INTEGER(KIND=2), POINTER,             INTENT(IN), OPTIONAL                   ::  values_int16_0d  !< output variable
+   INTEGER(KIND=4), POINTER,             INTENT(IN), OPTIONAL                   ::  values_int32_0d  !< output variable
+   INTEGER(iwp),    POINTER,             INTENT(IN), OPTIONAL                   ::  values_intwp_0d  !< output variable
+   INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int8_1d   !< output variable
+   INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int16_1d  !< output variable
+   INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int32_1d  !< output variable
+   INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_intwp_1d  !< output variable
+   INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int8_2d   !< output variable
+   INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int16_2d  !< output variable
+   INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int32_2d  !< output variable
+   INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_intwp_2d  !< output variable
+   INTEGER(KIND=1), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int8_3d   !< output variable
+   INTEGER(KIND=2), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int16_3d  !< output variable
+   INTEGER(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int32_3d  !< output variable
+   INTEGER(iwp),    POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_intwp_3d  !< output variable
 
    LOGICAL, INTENT(IN) ::  is_global  !< true if variable is global (same on all PE)
 
-   REAL(KIND=4), POINTER, INTENT(IN), OPTIONAL                               ::  var_real32_0d  !< output variable
-   REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  var_real32_1d  !< output variable
-   REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  var_real32_2d  !< output variable
-   REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  var_real32_3d  !< output variable
-
-   REAL(KIND=8), POINTER, INTENT(IN), OPTIONAL                               ::  var_real64_0d  !< output variable
-   REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  var_real64_1d  !< output variable
-   REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  var_real64_2d  !< output variable
-   REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  var_real64_3d  !< output variable
-
-   REAL(wp), POINTER, INTENT(IN), OPTIONAL                               ::  var_realwp_0d  !< output variable
-   REAL(wp), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  var_realwp_1d  !< output variable
-   REAL(wp), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  var_realwp_2d  !< output variable
-   REAL(wp), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  var_realwp_3d  !< output variable
+   REAL(KIND=4), POINTER,             INTENT(IN), OPTIONAL                   ::  values_real32_0d  !< output variable
+   REAL(KIND=8), POINTER,             INTENT(IN), OPTIONAL                   ::  values_real64_0d  !< output variable
+   REAL(wp),     POINTER,             INTENT(IN), OPTIONAL                   ::  values_realwp_0d  !< output variable
+   REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_real32_1d  !< output variable
+   REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_real64_1d  !< output variable
+   REAL(wp),     POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_realwp_1d  !< output variable
+   REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_real32_2d  !< output variable
+   REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_real64_2d  !< output variable
+   REAL(wp),     POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_realwp_2d  !< output variable
+   REAL(KIND=4), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_real32_3d  !< output variable
+   REAL(KIND=8), POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_real64_3d  !< output variable
+   REAL(wp),     POINTER, CONTIGUOUS, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_realwp_3d  !< output variable
 
 
@@ -571,126 +567,126 @@
    IF ( return_value == 0  .AND.  ( .NOT. is_global  .OR.  my_rank == master_rank ) )  THEN
 
-      WRITE( temp_string, * ) var_id
+      WRITE( temp_string, * ) variable_id
       CALL internal_message( 'debug', routine_name // ': write variable ' // TRIM( temp_string ) )
 
-      ndim = SIZE( bounds_start )
+      ndims = SIZE( bounds_start )
 
       !-- 8bit integer output
-      IF ( PRESENT( var_int8_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, (/ var_int8_0d /),       &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_int8_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_int8_1d,             &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_int8_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_int8_2d,             &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_int8_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_int8_3d,             &
+      IF ( PRESENT( values_int8_0d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_int8_0d /), &
+                                 start = bounds_start - bounds_origin + 1,   &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_int8_1d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int8_1d,     &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_int8_2d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int8_2d,     &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_int8_3d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int8_3d,     &
                                  start = bounds_start - bounds_origin + 1, &
                                  count = value_counts )
       !-- 16bit integer output
-      ELSEIF ( PRESENT( var_int16_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, (/ var_int16_0d /),      &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_int16_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_int16_1d,            &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_int16_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_int16_2d,            &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_int16_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_int16_3d,            &
+      ELSEIF ( PRESENT( values_int16_0d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_int16_0d /), &
+                                 start = bounds_start - bounds_origin + 1,    &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_int16_1d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int16_1d,    &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_int16_2d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int16_2d,    &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_int16_3d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int16_3d,    &
                                  start = bounds_start - bounds_origin + 1, &
                                  count = value_counts )
       !-- 32bit integer output
-      ELSEIF ( PRESENT( var_int32_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, (/ var_int32_0d /),      &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_int32_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_int32_1d,            &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_int32_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_int32_2d,            &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_int32_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_int32_3d,            &
+      ELSEIF ( PRESENT( values_int32_0d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_int32_0d /),  &
+                                 start = bounds_start - bounds_origin + 1,     &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_int32_1d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int32_1d,    &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_int32_2d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int32_2d,    &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_int32_3d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_int32_3d,    &
                                  start = bounds_start - bounds_origin + 1, &
                                  count = value_counts )
       !-- working-precision integer output
-      ELSEIF ( PRESENT( var_intwp_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, (/ var_intwp_0d /),      &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_intwp_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_intwp_1d,            &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_intwp_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_intwp_2d,            &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_intwp_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_intwp_3d,            &
+      ELSEIF ( PRESENT( values_intwp_0d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_intwp_0d /),  &
+                                 start = bounds_start - bounds_origin + 1,     &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_intwp_1d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_intwp_1d,    &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_intwp_2d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_intwp_2d,    &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_intwp_3d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_intwp_3d,    &
                                  start = bounds_start - bounds_origin + 1, &
                                  count = value_counts )
       !-- 32bit real output
-      ELSEIF ( PRESENT( var_real32_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, (/ var_real32_0d /),     &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_real32_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_real32_1d,           &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_real32_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_real32_2d,           &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_real32_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_real32_3d,           &
+      ELSEIF ( PRESENT( values_real32_0d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_real32_0d /), &
+                                 start = bounds_start - bounds_origin + 1,     &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_real32_1d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real32_1d,   &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_real32_2d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real32_2d,   &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_real32_3d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real32_3d,   &
                                  start = bounds_start - bounds_origin + 1, &
                                  count = value_counts )
       !-- 64bit real output
-      ELSEIF ( PRESENT( var_real64_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, (/ var_real64_0d /),     &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_real64_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_real64_1d,           &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_real64_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_real64_2d,           &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_real64_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_real64_3d,           &
+      ELSEIF ( PRESENT( values_real64_0d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_real64_0d /), &
+                                 start = bounds_start - bounds_origin + 1,     &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_real64_1d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real64_1d,   &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_real64_2d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real64_2d,   &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_real64_3d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_real64_3d,   &
                                  start = bounds_start - bounds_origin + 1, &
                                  count = value_counts )
       !-- working-precision real output
-      ELSEIF ( PRESENT( var_realwp_0d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, (/ var_realwp_0d /),     &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_realwp_1d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_realwp_1d,           &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_realwp_2d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_realwp_2d,           &
-                                 start = bounds_start - bounds_origin + 1, &
-                                 count = value_counts )
-      ELSEIF ( PRESENT( var_realwp_3d ) )  THEN
-         nc_stat = NF90_PUT_VAR( file_id, var_id, var_realwp_3d,           &
+      ELSEIF ( PRESENT( values_realwp_0d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, (/ values_realwp_0d /), &
+                                 start = bounds_start - bounds_origin + 1,     &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_realwp_1d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_realwp_1d,   &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_realwp_2d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_realwp_2d,   &
+                                 start = bounds_start - bounds_origin + 1, &
+                                 count = value_counts )
+      ELSEIF ( PRESENT( values_realwp_3d ) )  THEN
+         nc_stat = NF90_PUT_VAR( file_id, variable_id, values_realwp_3d,   &
                                  start = bounds_start - bounds_origin + 1, &
                                  count = value_counts )
@@ -698,8 +694,7 @@
          return_value = 1
          nc_stat = NF90_NOERR
-         WRITE( temp_string, '(": variable_id=",I6,", file_id=",I6)' ) var_id, file_id
+         WRITE( temp_string, '(": variable_id=",I6,", file_id=",I6)' ) variable_id, file_id
          CALL internal_message( 'error', routine_name // &
-                                TRIM( temp_string ) //   &
-                                ': no output values given' )
+                                ': no output values given ' // TRIM( temp_string ) )
       ENDIF
 
@@ -713,12 +708,13 @@
             WRITE( temp_string, * )  NF90_STRERROR( nc_stat )
 
-            ALLOCATE( dim_ids(ndim) )
-            ALLOCATE( dim_lengths(ndim) )
-
-            nc_stat = NF90_INQUIRE_VARIABLE( file_id, var_id, dimids=dim_ids )
+            ALLOCATE( dimension_ids(ndims) )
+            ALLOCATE( dimension_lengths(ndims) )
+
+            nc_stat = NF90_INQUIRE_VARIABLE( file_id, variable_id, dimids=dimension_ids )
 
             d = 1
-            DO WHILE ( d <= ndim .AND. nc_stat == NF90_NOERR )
-               nc_stat = NF90_INQUIRE_DIMENSION( file_id, dim_ids(d), len=dim_lengths(d) )
+            DO WHILE ( d <= ndims .AND. nc_stat == NF90_NOERR )
+               nc_stat = NF90_INQUIRE_DIMENSION( file_id, dimension_ids(d), &
+                                                 LEN=dimension_lengths(d) )
                d = d + 1
             ENDDO
@@ -728,11 +724,10 @@
                   'start=', bounds_start, ', count=', value_counts, ', origin=', bounds_origin
                CALL internal_message( 'error', routine_name //     &
-                                      ': error while writing: ' // &
-                                      TRIM( temp_string ) )
+                                      ': error while writing: ' // TRIM( temp_string ) )
             ELSE
                !-- Error occured during NF90_INQUIRE_VARIABLE or NF90_INQUIRE_DIMENSION
                CALL internal_message( 'error', routine_name //            &
                                       ': error while accessing file: ' // &
-                                      NF90_STRERROR( nc_stat ) )
+                                       NF90_STRERROR( nc_stat ) )
             ENDIF
 
@@ -740,6 +735,5 @@
             !-- Other NetCDF error
             CALL internal_message( 'error', routine_name //     &
-                                   ': error while writing: ' // &
-                                   NF90_STRERROR( nc_stat ) )
+                                   ': error while writing: ' // NF90_STRERROR( nc_stat ) )
          ENDIF
       ENDIF
@@ -761,7 +755,7 @@
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'netcdf4_finalize'  !< name of routine
 
-   INTEGER(iwp), INTENT(IN)  ::  file_id       !< file ID
-   INTEGER(iwp)              ::  nc_stat       !< netcdf return value
-   INTEGER(iwp), INTENT(OUT) ::  return_value  !< return value
+   INTEGER, INTENT(IN)  ::  file_id       !< file ID
+   INTEGER              ::  nc_stat       !< netcdf return value
+   INTEGER, INTENT(OUT) ::  return_value  !< return value
 
 
@@ -769,5 +763,5 @@
    WRITE( temp_string, * ) file_id
    CALL internal_message( 'debug', routine_name // &
-                                   ': close file (file_id=' // TRIM( temp_string ) // ')' )
+                          ': close file (file_id=' // TRIM( temp_string ) // ')' )
 
    nc_stat = NF90_CLOSE( file_id )
@@ -777,5 +771,5 @@
       return_value = 1
       CALL internal_message( 'error', routine_name // &
-                                      ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
+                             ': NetCDF error: ' // NF90_STRERROR( nc_stat ) )
    ENDIF
 #else
@@ -796,5 +790,5 @@
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'get_netcdf_data_type'  !< name of this routine
 
-   INTEGER(iwp) ::  return_value  !< netcdf data type
+   INTEGER ::  return_value  !< netcdf data type
 
 
@@ -823,6 +817,6 @@
       CASE DEFAULT
          CALL internal_message( 'error', routine_name // &
-                                         ': data type unknown (' // TRIM( data_type ) // ')' )
-         return_value = -1_iwp
+                                ': data type unknown (' // TRIM( data_type ) // ')' )
+         return_value = -1
 
    END SELECT
@@ -860,12 +854,14 @@
 !> Return the last created error message.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE netcdf4_get_error_message( error_message )
-
-   CHARACTER(LEN=800), INTENT(OUT) ::  error_message  !< return error message to main program
-
-
-   error_message = internal_error_message
-
-END SUBROUTINE netcdf4_get_error_message
+FUNCTION netcdf4_get_error_message() RESULT( error_message )
+
+   CHARACTER(LEN=800) ::  error_message  !< return error message to main program
+
+
+   error_message = TRIM( internal_error_message )
+
+   internal_error_message = ''
+
+END FUNCTION netcdf4_get_error_message
 
 
